<p-blockUI [target]="pnl"  [blocked]="isSpiner">
    <i class="pi pi-spin pi-spinner" style="font-size: 3rem"></i>
</p-blockUI>
<div class="card">
    <h5 class="text-blue-500 font-bold"><i class="pi pi-circle text-4xl"></i>จัดการบริการ</h5>
    <p-table #pnl #dt [value]="services" [paginator]="true" [rows]="10" [showCurrentPageReport]="true"
        responsiveLayout="scroll" currentPageReportTemplate="Showing {first} to {last} of {totalRecords} entries"
        [rowsPerPageOptions]="[10,25,50]" [globalFilterFields]="['service_type_name','service_name']"
        [rowHover]="true"> 
        <ng-template pTemplate="caption">
            <div class="flex flex-wrap gap-2 align-items-center justify-content-between">
                <span class="p-input-icon-left w-full sm:w-20rem flex-order-1 sm:flex-order-0">
                    <i class="pi pi-search"></i>
                    <input pInputText type="text" (input)="onGlobalFilter(dt, $event)" placeholder="ค้นหา"
                        class="w-full" />
                </span>
                <button (click)="displayFormAdd()" pButton
                    class="p-button w-full sm:w-auto flex-order-0 sm:flex-order-1" icon="pi pi-plus-circle" label="เพิ่มบริการ"></button>
            </div>
        </ng-template>
        <ng-template pTemplate="header">
            <tr>
                <th class="text-center">ลำดับ </th>
                <th pSortableColumn="service_name">คลินิก <p-sortIcon field="service_name"></p-sortIcon></th>
                <th pSortableColumn="service_type_name">บริการ<p-sortIcon field="service_type_name"></p-sortIcon></th>
                <th class="text-center"pSortableColumn="is_active">สถานะการใช้งาน <p-sortIcon field="is_active"></p-sortIcon></th>
                <th class="text-center"> </th>
        </ng-template>
        <ng-template pTemplate="body" let-services let-i="rowIndex">
            <tr>
                <td class="text-center">{{i+1}}</td>
                <td>{{services.service_name}}</td>
                <td>{{services.service_type_name}}</td>
                <td class="text-center">
                    <p-tag *ngIf="services.is_active" severity="success" value="เปิดใช้งาน"></p-tag>
                    <p-tag *ngIf="!services.is_active" severity="danger" value="ปิดใช้งาน"></p-tag>
                </td>
                <td class="text-center">
                    <button type="button" pButton pRipple icon="pi pi-pencil" class="h-1rem  mr-2 p-button-warning p-button-raised" (click)="displayFormEdit(services)"  pTooltip="แก้ไขข้อมูล" tooltipPosition="bottom"></button>
                </td>
        </ng-template>
    </p-table>
</div>
<p-dialog [(visible)]="displayForm" [breakpoints]="{'960px': '75vw', '640px': '100vw'}" [style]="{width: '50vw'}">
    <ng-template pTemplate="header">
        <h5 *ngIf="isAdd">เพิ่มบริการ</h5>
        <h5 *ngIf="isEdit">แก้ไขบริการ</h5>
        <p-messages [(value)]="messages" [enableService]="false" [closable]="false"></p-messages>
    </ng-template>
    <ng-template pTemplate="content">
        <div *ngIf="isAdd" class="p-fluid">
            <p-progressSpinner *ngIf="isSpiner" color="accent" styleClass="w-4rem h-4rem" strokeWidth="2"
                fill="var(--surface-ground)" animationDuration=".5s"></p-progressSpinner>
            <div class="grid" class="col-30 md:col-12">
                <div class="col-12 md:col-12">
                    <p-dropdown [options]="clinics" [(ngModel)]="selectedClinic" optionLabel="service_name"
                        optionValue="service_id">
                    </p-dropdown>
                </div>
                <div class="col-12 md:col-12">
                    <div class="p-inputgroup">
                        <span class="p-inputgroup-addon"><i class="pi pi-home"></i></span>
                        <input type="text" id="service_name" [(ngModel)]="serviceName" pInputText
                            placeholder="ชื่อบริการ">
                    </div>
                </div>
                <div class="col-12 md:col-12">
                    <div class="p-inputgroup">
                        <span class="p-inputgroup-addon"><i class="pi pi-file-import"></i></span>
                        <input type="text" id="urlIcone" [(ngModel)]="urlIcone" pInputText placeholder="รูปภาพ">
                    </div>
                </div>
                <div class="col-12 md:col-12">

                    <div class="p-inputgroup">
                        <span class="p-inputgroup-addon"><i class="pi pi-comment"></i></span>
                        <input type="text" id="serviceNote" name="serviceNote" [(ngModel)]="serviceNote"
                            placeholder="หมายเหตุ" pInputText>
                    </div>
                </div>
            </div>
        </div>
        <div *ngIf="isEdit" class="p-fluid">
            <div class="grid" class="col-30 md:col-12">
                <div class="col-12 md:col-12">
                    <p-dropdown [options]="clinics" [(ngModel)]="selectedClinic" optionLabel="service_name"
                        optionValue="service_id">
                    </p-dropdown>
                </div>
                <div class="col-12 md:col-12">
                    <div class="p-inputgroup">
                        <span class="p-inputgroup-addon"><i class="pi pi-home"></i></span>
                        <input type="text" id="service_name" [(ngModel)]="serviceNameEdit" pInputText>
                    </div>
                </div>
                <div class="col-12 md:col-12">
                    <div class="p-inputgroup">
                        <span class="p-inputgroup-addon"><i class="pi pi-comment"></i></span>
                        <input type="text" id="serviceNote" [(ngModel)]="serviceNote" pInputText>
                    </div>
                </div>
                <div class="col-12 md:col-12">
                    <div class="p-inputgroup">
                        <span class="p-inputgroup-addon"><i class="pi pi-file-import"></i></span>
                        <input type="text" id="urlIconeEdit" [(ngModel)]="urlIconeEdit" pInputText>
                    </div>
                </div>
                <div class="p-field">
                    <label for="service_name">สถานะการใช้งาน</label>
                    <div class="p-formgroup-inline">
                        <p-inputSwitch [(ngModel)]="serviceActiveEdit"></p-inputSwitch>
                    </div>
                </div>
            </div>
        </div>
    </ng-template>
    <ng-template pTemplate="footer">
        <button *ngIf="isAdd" type="button" pButton icon="pi pi-check" class="p-button-raised p-button-success"
            (click)="save()" label="เพิ่มรายการ">
        </button>
        <button *ngIf="isEdit" type="button" pButton icon="pi pi-check" class="p-button-raised p-button-success"
            (click)="update()" label="บันทึกแก้ไข"></button>
    </ng-template>
</p-dialog>